<?php 
JFormHelper::loadFieldClass('list');

class JFormFieldVmOrderStatus extends JFormFieldList
{
    protected $type = 'VmOrderStatus';

    protected function getInput()
    {
        vmJsApi::addJScript('adminvtbpay', '/plugins/vmpayment/vtbpay/assets/js/admin_vtbpay.js');
        $db = JFactory::getDBO();
        $prefix = $db->getPrefix();
        $query = $db->getQuery(true);
        $query->select($db->quoteName(['order_status_code', 'order_status_name']));
        $query->from($db->quoteName($prefix . 'virtuemart_orderstates'));
        $db->setQuery($query);
        $results = $db->loadObjectList();
        $selected = $options = [];
        
        $defaultStatus = 'C';

        if ($results) {
            foreach($results as $result) {
                $option = JHtml::_('select.option', $result->order_status_code, JText::_($result->order_status_name));
                $options[] = $option;
                if(
                  $result->order_status_code === $this->value ||
                  $result->order_status_code === $defaultStatus && $this->value == ''
                )
                {
                  $selected[] = $option;
                }
            }
        }
        
        return JHtml::_('select.genericlist', $options, $this->name, '', 'value', 'text', $selected, $this->id);
    }
}
